//---------------------------------------------------------------------------

#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Chart.hpp>
#include <ExtCtrls.hpp>
#include <Series.hpp>
#include <TeEngine.hpp>
#include <TeeProcs.hpp>
#include <Chartfx3.hpp>
#include <OleCtrls.hpp>
#include "CPort.hpp"
#include <ComCtrls.hpp>
#include <TeeFunci.hpp>
//---------------------------------------------------------------------------
class TTestForm : public TForm
{
__published:	// IDE-managed Components
        TButton *btnConnect;
        TButton *btnExit;
        TChart *Chart1;
        TMemo *mmInfo;
        TStatusBar *StatusBar1;
        TChart *Chart2;
        TComboBox *cbCom;
        TAddTeeFunction *TeeFunction1;
        TLabel *lbRazv;
        TComboBox *cbTrigger;
        TLineSeries *Series2;
        TLabel *Label2;
        TComboBox *cbRazv;
        TLabel *lbTrigger;
        TLabel *Label3;
        TTrackBar *tbPhase;
        TLabel *lbPhase;
        TLabel *lbLevel;
        TTrackBar *tbLevel;
        TPointSeries *Series3;
        TFastLineSeries *Series1;
        TPanel *Panel1;
        TCheckBox *cbFFTEnabled;
        void __fastcall btnConnectClick(TObject *Sender);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall btnExitClick(TObject *Sender);
        void __fastcall cbRazvChange(TObject *Sender);
        void __fastcall FormResize(TObject *Sender);
private:	// User declarations
public:		// User declarations
        __fastcall TTestForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TTestForm *TestForm;
//---------------------------------------------------------------------------
#endif
