/*****************************************************
This program was produced by the
CodeWizardAVR V1.24.8 Cracked
Automatic Program Generator

Project : - ()
Version : 00
Date    : 29.01.2006
Author  : SiNil
Company : 
Comments: 


Chip type           : ATmega16
Program type        : Application
Clock frequency     : 14,745600 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

#include <mega16.h> 
#include <delay.h> 

#define UDRE UCSRA.5
#define BUFFER 800

// Standard Input/Output functions
#include <stdio.h> 

void init (void);


void readADC_3  (void);         //   
void readADC_6  (void);         //     2  
void readADC    (char count);   //        
void delay_3    (unsigned char adjust);

void tx_fast    (void);         //  

// Declare your global variables here
signed char     adc_array [BUFFER] @0xC0;   //  
char            pre_query[8];

void main(void)
{
// Declare your local variables here

//      :
char query[8];

//  - -
char* ERROR_CODE = "error";

//  -  :
unsigned char i;

//  - .    . 
unsigned char adjust;

//  :
init();  

while (1)
  {
  // Place your code here

/* 
*******************/
for (i=0; i<8; i++)
{       
        pre_query[i]=query[i];
        query[i]=getchar();
        if (query[i]=='q') i=0;
};

adjust=query[2]*3;


/* 
*******************/
if (query[0] == 'q')
{                 
        delay_3(adjust);
        tx_fast();
        switch (query[1]) {
                case 1:
                        readADC_3();
                        break;            
                case 2:
                        readADC_6();
                        break;
                case 3:
                        readADC(0xfe);
                        break;
                case 4:
                        readADC(0xf9);
                        break;
                case 5:
                        readADC(0xea);
                        break;
                case 6:
                        readADC(0xd1);
                        break;
                case 7:
                        readADC(0x86);
                        break;
                case 8:
                        readADC(0x09);
                        break;
                default:
                        puts (ERROR_CODE);                        
                };
}
else puts (ERROR_CODE);    
  };
} 

void init (){    
// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=Out 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=0 
PORTA=0x00;
DDRA=0x01;

// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x00;

// Port C initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0 output: Disconnected
TCCR0=0x00;
TCNT0=0x00;
OCR0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: Off
MCUCR=0x00;
MCUCSR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;

// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud rate: 115200
UCSRA=0x00;
UCSRB=0x18;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x07; 

// // USART initialization
// // Communication Parameters: 8 Data, 1 Stop, No Parity
// // USART Receiver: On
// // USART Transmitter: On
// // USART Mode: Asynchronous
// // USART Baud rate: 57600
// UCSRA=0x00;
// UCSRB=0x18;
// UCSRC=0x86;
// UBRRH=0x00;
// UBRRL=0x0F;

 
// // USART initialization
// // Communication Parameters: 8 Data, 1 Stop, No Parity
// // USART Receiver: Off
// // USART Transmitter: On
// // USART Mode: Asynchronous
// // USART Baud rate: 57600
// UCSRA=0x00;
// UCSRB=0x18;
// UCSRC=0x86;
// UBRRH=0x00;
// UBRRL=0x0F;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;
}

void tx_fast (void)    {
        unsigned int i;
        bit ss=1;
        char sst;
        
        
        //   "answer",    
        putchar('a');
        putchar('n');
        putchar('s');
        putchar('w');
        putchar('e');
        putchar('r');

        for (i=0; i<8; i++) {
                putchar(pre_query[i]);
                }
        
        //   FF  00        
        for (i=0; i<98; i++) {
                if (ss) sst=0xFF;
                else    sst=0x00;
                ss=~ss;
                putchar(sst);
//                 while (!UDRE);
//                         /*    ,   */
//                 UDR = sst;//putchar(adc_array[i]);
               }
        for (i=0; i<BUFFER; i++) {
               putchar(adc_array[i]);
                        /*      */
//                 while (!UDRE);
//                         /*    ,   */
//                 UDR = adc_array[i];//putchar(adc_array[i]);
               };
        for (i=0; i<112; i++) {
                if (ss) sst=0xFF;
                else    sst=0x00;
                ss=~ss;
                putchar(sst);
//                 while (!UDRE);
//                         /*    ,   */
//                 UDR = sst;//putchar(adc_array[i]);
               }
}
